#property copyright "www,forex-station.com"
#property link      "www,forex-station.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  3
#property indicator_width4  3
#property strict

//
//
//
//
//

extern int                Kijun            = 26;                // Kijun sen period
extern ENUM_APPLIED_PRICE Price            = PRICE_CLOSE;       // Price to use for the cross
extern bool               alertsOn         = true;              // Turn alerts on?
extern bool               alertsOnCurrent  = false;             // Alerts on current (still opened) bar?
extern bool               alertsMessage    = true;              // Alerts should display a message?
extern bool               alertsSound      = false;             // Alerts should play a sound?
extern bool               alertsEmail      = false;             // Alerts should send an email?
extern bool               alertsNotify     = false;             // Alerts should send notification?
extern string             soundFile        = "alert2.wav";      // Sound file

double tkhu[],tkhd[],tkhbu[],tkhbd[],ks[],trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
     IndicatorBuffers(6);
     SetIndexBuffer(0,tkhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
     SetIndexBuffer(1,tkhd);  SetIndexStyle(1,DRAW_HISTOGRAM);
     SetIndexBuffer(2,tkhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
     SetIndexBuffer(3,tkhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
     SetIndexBuffer(4,ks);  
     SetIndexBuffer(5,trend); 
     
    IndicatorShortName("Price crossing Kijun Sen Candles");
   return(0);
}
int deinit() {  return(0);}

//
//
//
//                           
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;
   
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-Kijun); 
   
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
       double prc = iMA(NULL,0,1,0,MODE_SMA,Price,i);
       double khi = High[i];
       double klo = Low[i];
       for (k=1; k<Kijun && (i+k)<Bars; k++)
       {
           if(khi<High[i+k]) khi = High[i+k];
           if(klo> Low[i+k]) klo =  Low[i+k];
        } 
        ks[i] = ((khi+klo) > 0.0) ? (khi+klo)*0.5 : 0;
        trend[i] = (i<Bars-1) ? (prc>ks[i]) ? 1 : (prc<ks[i]) ? -1 : trend[i+1] : 0; 
        if (trend[i]== 1)
        {
          tkhu[i]  = High[i]; 
          tkhd[i]  = Low[i];
          tkhbu[i] = fmax(Open[i],Close[i]);
          tkhbd[i] = fmin(Open[i],Close[i]);
        }               
        if (trend[i]== -1)
        {
          tkhu[i]  = Low[i];
          tkhd[i]  = High[i];
          tkhbu[i] = fmin(Open[i],Close[i]);
          tkhbd[i] = fmax(Open[i],Close[i]);
        }               
     }
     if (alertsOn)
     {
        int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert(" crossing price up");
        else  doAlert(" crossing price down");       
   }
return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Kijun Sen ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Kijun Sen ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


      
   


